// blloader.cpp
// (c)  , telepat@inbox.ru
#include "StdAfx.h"
#include "../_common/contextimpl.hpp"
#include "../_common/addin/addin.hpp"
#include <atlbase.h>

typedef HRESULT(__stdcall *PDllGetClassObject)(const CLSID&, const IID&, void ** ppv);

struct addin_info
{
	addin_info():pFunc(NULL){}
	addin_info(LPCSTR pStart, LPCSTR pEnd):strProgID(pStart, pEnd-pStart), pFunc(NULL){strProgID.MakeLower();}
	CString strProgID;
	CLSID clsid;
	PDllGetClassObject pFunc;
};
typedef CArray<addin_info, addin_info> addin_array;

using namespace context_obj::str_find;

class addin_mgr
{
	typedef HRESULT(__stdcall *PCLSIDFromProgID)(LPCOLESTR, LPCLSID);
	typedef HRESULT(__stdcall *PCoCreateInstance)(REFCLSID, LPUNKNOWN, DWORD, REFIID, LPVOID*);

	addin_array array;
	PCLSIDFromProgID pClsFromProg7;
	PCoCreateInstance pCoCreate7;
	PCoCreateInstance pCoCreateF;
	addin_mgr():pClsFromProg7(NULL){}
	
	static HRESULT __stdcall ClassFromProg(LPCOLESTR bstrPropgID, LPCLSID pClsID)
	{
		USES_CONVERSION;
		CString strProgID=OLE2A(bstrPropgID);
		strProgID.MakeLower();
		for(int i=0;i<mgr.array.GetSize();i++)
		{
			if(strProgID==mgr.array[i].strProgID)
			{
				*pClsID=mgr.array[i].clsid;
				return S_OK;
			}
		}
		return mgr.pClsFromProg7(bstrPropgID, pClsID);
	}
	
	static inline HRESULT CoCreate(REFCLSID clsid, LPUNKNOWN pUnk, DWORD dwCtx, REFIID iid, LPVOID* ppRet, PCoCreateInstance pOld)
	{
		for(int i=0;i<mgr.array.GetSize();i++)
		{
			if(InlineIsEqualGUID(clsid, mgr.array[i].clsid))
			{
				IClassFactoryPtr pFactory;
				HRESULT hr=mgr.array[i].pFunc(clsid, IID_IClassFactory, reinterpret_cast<void**>(&pFactory));
				if(S_OK==hr)
					return pFactory->CreateInstance(pUnk, iid, ppRet);
				return hr;
			}
		}
		return pOld(clsid, pUnk, dwCtx, iid, ppRet);
	}
	
	static HRESULT __stdcall CoCreate7(REFCLSID clsid, LPUNKNOWN pUnk, DWORD dwCtx, REFIID iid, LPVOID* ppRet)
	{
		return CoCreate(clsid, pUnk, dwCtx, iid, ppRet, mgr.pCoCreate7);
	}
	static HRESULT __stdcall CoCreateF(REFCLSID clsid, LPUNKNOWN pUnk, DWORD dwCtx, REFIID iid, LPVOID* ppRet)
	{
		return CoCreate(clsid, pUnk, dwCtx, iid, ppRet, mgr.pCoCreateF);
	}

	void _AddAddins(addin_array& arr)
	{
		for(int i=0;i<arr.GetSize();i++)
		{
			for(int j=0;j<array.GetSize();j++)
			{
				if(arr[i].strProgID==array[j].strProgID)
					break;
			}
			if(j==array.GetSize())
				array.Add(arr[i]);
		}
		if(!pClsFromProg7)
		{
			PCLSIDFromProgID* pThunkCFP=reinterpret_cast<PCLSIDFromProgID*>(addin::impl_trap::GetThunkAddres("seven.dll", "ole32.dll", "CLSIDFromProgID"));
			pClsFromProg7=*pThunkCFP;
			*pThunkCFP=ClassFromProg;

			PCoCreateInstance* pThunkCC=reinterpret_cast<PCoCreateInstance*>(addin::impl_trap::GetThunkAddres("seven.dll", "ole32.dll", "CoCreateInstance"));
			pCoCreate7=*pThunkCC;
			*pThunkCC=CoCreate7;
			
			pThunkCC=reinterpret_cast<PCoCreateInstance*>(addin::impl_trap::GetThunkAddres("frame.dll", "ole32.dll", "CoCreateInstance"));
			pCoCreateF=*pThunkCC;
			DWORD old;
			VirtualProtect(pThunkCC, 4, PAGE_EXECUTE_READWRITE, &old);
			*pThunkCC=CoCreateF;
		}
	}

	static addin_mgr mgr;
	
public:

	static void AddAddins(addin_array& array)
	{
		mgr._AddAddins(array);
	}
};
addin_mgr addin_mgr::mgr;


enum errCodes
{
	errSuccess,
	errBadParam,
	errBadFile,
	errNoProgIDs,
	wrnNotAllClsIDs,
	errNoClsIDs,
	errNoGetObject,
};

class CLoadResult : public CContextImpl<CLoadResult, no_init_done>
{
	int m_iResult;
	CString m_strResult;
	CLoadResult(CValue& val, int iResult, LPCSTR strResult)
		:m_iResult(iResult), m_strResult(strResult)
	{
		val.AssignContext(this);
		DecrRef();
	}

public:
	BL_BEGIN_CONTEXT("ExecuteResult", "");

		BL_PROP_RO(ErrorCode, "")
			{value = m_iResult;return TRUE;}

		BL_PROP_RO(Result, "")
			{value=m_strResult;return TRUE;}

	BL_END_CONTEXT();

	static void AssignResult(CValue& val, int iResult, LPCSTR strResult)
	{
		new CLoadResult(val, iResult, strResult);
	}
};

class CBLLoader : public CContextImpl<CBLLoader>
{
public:
	BL_BEGIN_CONTEXT("AddinLoader", "");

		BL_FUNC(LoadAddin, "", 2)
			{LoadAddin(retVal, ppParams[0], ppParams[1]);return TRUE;}
		
		BL_FUNC(GetLoadCode, "", 1)
			{GetLoadCode(retVal, ppParams[0]);return TRUE;}

	BL_END_CONTEXT();

protected:
	void LoadAddin(CValue& retVal, CValue* pFile, CValue* pProgClassID)
	{
		if(pFile->type != 2)
		{
			CLoadResult::AssignResult(retVal, errBadParam, "   ");
			return;
		}
		if(pProgClassID->type != 2)
		{
			CLoadResult::AssignResult(retVal, errBadParam, "   ");
			return;
		}
		addin_array arrIDs;
		CString strClsIDs=pProgClassID->GetString();
		for(LPCSTR pRead=strClsIDs, pStart=pRead;;)
		{
			while(symbol(pRead) && symbol(pRead)!=static_cast<DWORD>('\r'))
				pRead++;
			if(pRead > pStart + 43)
			{
				CString line(pStart, pRead-pStart);
				LPCSTR ptr=line;
				while(symbol(ptr) && symbol(ptr)!=static_cast<DWORD>('='))
					ptr++;
				if(symbol(ptr)==static_cast<DWORD>('='))
				{
					addin_info info(line, ptr);
					if(0==info.strProgID.Find("addin.") &&
						RPC_S_OK==UuidFromString(reinterpret_cast<BYTE*>(const_cast<char*>(++ptr)), &info.clsid))
						arrIDs.Add(info);
				}
			}
			while(symbol(pRead) && symbol(pRead)<32)
				pRead++;
			if(!symbol(pRead))
				break;
			pStart=pRead;
		}
		if(!arrIDs.GetSize())
		{
			CLoadResult::AssignResult(retVal, errNoClsIDs, "   ");
			return;
		}
		CString strFileName=pFile->GetString();
		BOOL bNeedFree=FALSE;
		HINSTANCE hInst=GetModuleHandle(strFileName);
		if(!hInst)
		{
			hInst=LoadLibrary(strFileName);
			bNeedFree=TRUE;
		}
		if(!hInst)
		{
			CString errMsg="   \"";
			errMsg+=strFileName+"\".\r\n"+GetErrorDescription();
			CLoadResult::AssignResult(retVal, errBadFile, errMsg);
			return;
		}
		PDllGetClassObject pFunc=reinterpret_cast<PDllGetClassObject>(GetProcAddress(hInst, "DllGetClassObject"));
		if(!pFunc)
		{
			CLoadResult::AssignResult(retVal, errNoGetObject, "   DllGetClassObject");
			if(bNeedFree)
				FreeLibrary(hInst);
			return;
		}
		for(int i=0;i<arrIDs.GetSize();i++)
			arrIDs[i].pFunc=pFunc;
		addin_mgr::AddAddins(arrIDs);

		DWORD loaded=0;
		CString strResult=":\r\n";

		for(i=0;i<arrIDs.GetSize();i++)
		{
			if(pMainApp->AttachAddInDLL(arrIDs[i].strProgID))
			{
				loaded++;
				strResult+=arrIDs[i].strProgID+"\r\n";
			}
		}
		CLoadResult::AssignResult(retVal, loaded==arrIDs.GetSize() ? errSuccess : wrnNotAllClsIDs, strResult);
		return;
	}

	int GetCLSID(CStringArray& arrProgIDs, CStringArray& arrCLSIDs)
	{
		int nsize=arrProgIDs.GetSize(), progIDs=0;
		CLSID clsid;
		for(int i=0;i<nsize;i++)
		{
			if(S_OK==CLSIDFromProgID(_bstr_t(arrProgIDs[i]), &clsid))
			{
				BYTE* pString;
				if(RPC_S_OK==UuidToString(&clsid, &pString))
				{
					arrCLSIDs[i]=(reinterpret_cast<LPCSTR>(pString));
					RpcStringFree(&pString);
					progIDs++;
				}
			}
		}
		return progIDs;
	}

	void GetLoadCode(CValue& retVal, CValue* pFile)
	{
		if(pFile->type!=2)
		{
			CLoadResult::AssignResult(retVal, errBadParam, "  ");
			return;
		}
		CString strFileName=pFile->GetString();
		BOOL bNeedFree=FALSE;
		HINSTANCE hInst=GetModuleHandle(strFileName);
		if(!hInst)
		{
			bNeedFree=TRUE;
			hInst=LoadLibraryEx(strFileName, NULL, LOAD_LIBRARY_AS_DATAFILE);
		}
		if(!hInst)
		{
			CString errMsg="   \"";
			errMsg+=strFileName+"\".\r\n"+GetErrorDescription();
			CLoadResult::AssignResult(retVal, errBadFile, errMsg);
			return;
		}
		char buf[MAX_PATH];
		if(!LoadString(hInst, 100, buf, MAX_PATH))
			_splitpath(strFileName, NULL, NULL, buf, NULL);
		if(bNeedFree)
			FreeLibrary(hInst);

		CStringArray arrProgIDs, arrCLSIDs;

		for(LPCSTR pStart=buf, pRead=pStart;;)
		{
			while(symbol(pRead) && symbol(pRead)!=static_cast<DWORD>('|'))
				pRead++;
			if(pRead>pStart)
				arrProgIDs.Add(CString("Addin.")+CString(pStart, pRead-pStart));
			if(!symbol(pRead))
				break;
			pStart=++pRead;
		}
		int nProgIDs=arrProgIDs.GetSize();
		if(!nProgIDs)
		{
			CLoadResult::AssignResult(retVal, errNoProgIDs, "  ProgID");
			return;
		}
		arrCLSIDs.SetSize(nProgIDs);
		
		int nClassIDs=GetCLSID(arrProgIDs, arrCLSIDs);
		if(nProgIDs > nClassIDs) //    ProgID   CLSID
		{
			if(bNeedFree)
				hInst=LoadLibrary(strFileName);
			if(hInst)
			{
				HRESULT (__stdcall *func)()=reinterpret_cast<HRESULT (__stdcall*)()>(
					GetProcAddress(hInst, "DllRegisterServer"));
				if(func)
				{
					func();
					nClassIDs=GetCLSID(arrProgIDs, arrCLSIDs);
				}
				if(bNeedFree)
					FreeLibrary(hInst);
			}
		}
		CString strResult;
		int iResult;
		if(nClassIDs)
		{
			strResult="\t = (\"\");\r\n\t = .(\""+strFileName+"\", \"";
			for(int i=0;i<nProgIDs;i++)
			{
				strResult += arrProgIDs[i]+"="+arrCLSIDs[i];
				strResult += i==nProgIDs-1 ? "\");\r\n" : "\r\n\t\t|";
			}
			iResult = nClassIDs==nProgIDs ? errSuccess : wrnNotAllClsIDs;
		}
		else
		{
			iResult=errNoClsIDs;
			strResult="    ";
		}
		CLoadResult::AssignResult(retVal, iResult, strResult);
		return;
	}
};

BL_INIT_CONTEXT(CBLLoader);